
// --- Rings.
//  Copyright (c) 2000. Remage / Fresh!mindworkz.

Object Rings;

void Rings_Init( void )
  {
    Rings.NumVects = 64*8*32;
    if (( Rings.Vects = (Vect*) malloc( Rings.NumVects * sizeof( Vect ))) == NULL )
      PostQuitMessage( 0 );

    Rings.NumFaces = 64*8*32;
    if (( Rings.Faces = (Face*) malloc( Rings.NumFaces * sizeof( Face ))) == NULL )
      PostQuitMessage( 0 );
   }

void Rings_Draw( float Timer )
  {
    int F=0, V=0;

    // Gen Objects.
    for ( int i = 0; i < 31; i++ )
      {
        float Shd, Tim2 = Timer + 0.5f * Fsin( Timer );

        for ( int j = 0; j < 64; j++ )
          {
            float Rad = 2.7f + 1.3f * Fsin( Timer*0.009f + i*0.4f )+ ( 0.6f + 0.4f * Fsin( Timer*0.007f + i*0.2f )) * Fsin( Timer*0.01f + i*0.3f + 3 * j * Pi / 32 );
   
            Vertex( &(Rings.Vects[ V + j*8 +0 ]), 3*(0.20f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.20f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 16.2f );
            Vertex( &(Rings.Vects[ V + j*8 +1 ]), 3*(0.18f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.18f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 16.4f );
            Vertex( &(Rings.Vects[ V + j*8 +2 ]), 3*(0.02f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.02f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 16.4f );
            Vertex( &(Rings.Vects[ V + j*8 +3 ]), 3*(0.00f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.00f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 16.2f );
            Vertex( &(Rings.Vects[ V + j*8 +4 ]), 3*(0.00f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.00f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 15.8f );
            Vertex( &(Rings.Vects[ V + j*8 +5 ]), 3*(0.02f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.02f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 15.6f );
            Vertex( &(Rings.Vects[ V + j*8 +6 ]), 3*(0.18f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.18f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 15.6f );
            Vertex( &(Rings.Vects[ V + j*8 +7 ]), 3*(0.20f+Rad) * Fsin( (float) j * Pi / 32.0f ), 3*(0.20f+Rad) * Fcos( (float) j * Pi / 32.0f ), i - 15.8f );
           }

        for ( j = 0; j < 64; j++ )
          {
            float dX, dY, dZ, Vlight, CDist;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 0;
            Rings.Faces[ F ].B = V + j*8 + 1;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 1;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 0;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 0 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 1 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 1 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 0 ];
              dX = Rings.Faces[ F ].pA->X - Rings.Faces[ F ].pD->X;
              dY = Rings.Faces[ F ].pA->Y - Rings.Faces[ F ].pD->Y;
              Vlight = 0.00392f * ( 1.0f + 0.6f * ( 1.0f + dX / Fsqrt( dX*dX + dY*dY )));
            Rings.Faces[ F ].ColR = Vlight * ( 85 );
            Rings.Faces[ F ].ColG = Vlight * ( 112 );
            Rings.Faces[ F ].ColB = Vlight * ( 97 );
              Shd = 1.0f - Fabs( i - 15.0f ) * 0.0667f;
              dX = Rings.Faces[ F ].pA->X - Camp.X;
              dY = Rings.Faces[ F ].pA->Y - Camp.Y;
              dZ = Rings.Faces[ F ].pA->Z - Camp.Z;
              CDist = Fsqrt( dX*dX + dY*dY + dZ*dZ ) * 0.04f;
              if ( CDist > 1.0f ) CDist = 1.0f;
              Shd *= 1.0f - CDist;
              if ( Shd > 0.8f ) Shd = 0.8f;
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 1;
            Rings.Faces[ F ].B = V + j*8 + 2;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 2;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 1;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 1 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 2 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 2 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 1 ];
            Rings.Faces[ F ].ColR = Vlight * ( 79 );
            Rings.Faces[ F ].ColG = Vlight * ( 104 );
            Rings.Faces[ F ].ColB = Vlight * ( 91 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 2;
            Rings.Faces[ F ].B = V + j*8 + 3;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 3;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 2;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 2 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 3 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 3 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 2 ];
            Rings.Faces[ F ].ColR = Vlight * ( 71 );
            Rings.Faces[ F ].ColG = Vlight * ( 94 );
            Rings.Faces[ F ].ColB = Vlight * ( 82 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 3;
            Rings.Faces[ F ].B = V + j*8 + 4;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 4;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 3;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 3 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 4 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 4 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 3 ];
            Rings.Faces[ F ].ColR = Vlight * ( 64 );
            Rings.Faces[ F ].ColG = Vlight * ( 84 );
            Rings.Faces[ F ].ColB = Vlight * ( 73 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 4;
            Rings.Faces[ F ].B = V + j*8 + 5;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 5;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 4;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 4 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 5 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 5 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 4 ];
            Rings.Faces[ F ].ColR = Vlight * ( 54 );
            Rings.Faces[ F ].ColG = Vlight * ( 71 );
            Rings.Faces[ F ].ColB = Vlight * ( 62 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 5;
            Rings.Faces[ F ].B = V + j*8 + 6;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 6;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 5;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 5 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 6 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 6 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 5 ];
            Rings.Faces[ F ].ColR = Vlight * ( 60 );
            Rings.Faces[ F ].ColG = Vlight * ( 79 );
            Rings.Faces[ F ].ColB = Vlight * ( 68 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 6;
            Rings.Faces[ F ].B = V + j*8 + 7;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 7;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 6;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 6 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 7 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 7 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 6 ];
            Rings.Faces[ F ].ColR = Vlight * ( 68 );
            Rings.Faces[ F ].ColG = Vlight * ( 89 );
            Rings.Faces[ F ].ColB = Vlight * ( 77 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;

            Rings.Faces[ F ].Type = 4;
            Rings.Faces[ F ].A = V + j*8 + 7;
            Rings.Faces[ F ].B = V + j*8 + 0;
            Rings.Faces[ F ].C = V + ((j+1)&63)*8 + 0;
            Rings.Faces[ F ].D = V + ((j+1)&63)*8 + 7;
            Rings.Faces[ F ].pA = &Rings.Vects[ V + j*8 + 7 ];
            Rings.Faces[ F ].pB = &Rings.Vects[ V + j*8 + 0 ];
            Rings.Faces[ F ].pC = &Rings.Vects[ V + ((j+1)&63)*8 + 0 ];
            Rings.Faces[ F ].pD = &Rings.Vects[ V + ((j+1)&63)*8 + 7 ];
            Rings.Faces[ F ].ColR = Vlight * ( 75 );
            Rings.Faces[ F ].ColG = Vlight * ( 99 );
            Rings.Faces[ F ].ColB = Vlight * ( 86 );
            Rings.Faces[ F++ ].Shade = 1.25f*Shd;
           }
        V += 8*64;
       }

    Rings.NumFaces = F; 
    Rings.NumVects = V;
  
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective( 90.0f, 640.0f / 360.0f, 0.01f, 10.0f ); 
    glScalef( 0.2f, 0.2f, 0.2f );

    Camp.X = 7.3f + 5.0f * Fsin( Timer*0.00029f );
    Camp.Y = 7.3f + 5.0f * Fsin( Timer*0.00029f );
    Camp.Z = 0.5f;

    gluLookAt( Camp.X, Camp.Y, Camp.Z, 2.0f*Fsin( Timer*0.005f ), 2.0f*Fcos( Timer*0.0037f ), 4.0f*Fsin( Timer*0.0031f ), 0.0f, Fsin( Timer*0.0003f), Fcos( Timer*0.0003f ));
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();

    DrawObject( &Rings, 0.0f, 0.0f, 0.0f );
   }
